/*
 * helper.c - Implement helper funcs from helper.h
 */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <netdb.h>
#include "helper.h"

void err_quit(char *msg)
{
     perror(msg);
     exit(EXIT_FAILURE);
}

void herr_quit(char *msg)
{
     herror(msg);
     exit(EXIT_FAILURE);
}

void xfer_data(int srcfd, int tgtfd)
{
     char buf[1024];		/* data buffer */
     int cnt, len = 0;

     /* Read from the input fd and write to the output fd */
     while((cnt = read(srcfd, buf, sizeof(buf))) > 0) {
	  if(len < 0)
	       err_quit("helper.c:xfer_data:read");
	  if((len = write(tgtfd, buf, cnt)) != cnt)
	       err_quit("helper.c:xfer_data:write");
     }
}  
