/*
 * wrnet.c - Write to an open TCP/IP socket
 */
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdlib.h>
#include <stdio.h>
#include "helper.h"

int main(int argc, char *argv[])
{
     int sockfd;		/* File descriptor for socket */
     struct sockaddr_in cli;	/* Client's socket structure */
     socklen_t socklen;		/* Size of sockaddr */
     
     /* Expect the IP addresss on the command-line */
     if(argc != 2) {
	  puts("USAGE: wrnet <ip address>");
	  exit(EXIT_FAILURE);
     }

     /* Create a socket */
     if((sockfd = socket(PF_INET, SOCK_STREAM, 0)) < 0)
	  err_quit("socket");

     /* Set up the client */
     memset(&cli, 0, sizeof(cli));
     cli.sin_family = AF_INET;
     cli.sin_port = htons(50000);
     /* This will blow up if an invalid address is passed */
     if(!(inet_aton(argv[1], &cli.sin_addr)))
	  herr_quit("inet_aton");

     /* Connect to the socket */
     socklen = sizeof(cli);
     if(connect(sockfd, (struct sockaddr *)&cli, socklen))
	  err_quit("connect");
     puts("connected to TCP/IP socket");
     printf("\tport %d\n", ntohs(cli.sin_port));
     printf("\taddr %s\n", inet_ntoa(cli.sin_addr));

     /* Copy stdin to the socket file descriptor */
     xfer_data(fileno(stdin), sockfd);

     exit(EXIT_SUCCESS);
}
     
