/*
 * wrsock.c - Write to an open socket
 */
#include <sys/socket.h>
#include <sys/un.h>
#include <stdlib.h>
#include <stdio.h>
#include "helper.h"

int main(int argc, char *argv[])
{
     int sockfd;		/* File descriptor for socket */
     struct sockaddr_un cli;	/* Client's socket structure */
     socklen_t socklen;		/* Size of sockaddr */
     
     /* Expect the socket name on the command-line */
     if(argc != 2) {
	  puts("USAGE: sockconn <filename>");
	  exit(EXIT_FAILURE);
     }

     /* Create a socket */
     if((sockfd = socket(PF_UNIX, SOCK_STREAM, 0)) < 0)
	  err_quit("socket");

     /* Set up the client */
     memset(&cli, 0, sizeof(cli));
     cli.sun_family = AF_UNIX;
     strncpy(cli.sun_path, argv[1], sizeof(cli.sun_path));

     /* Connect to the socket */
     socklen = SUN_LEN(&cli);
     if(connect(sockfd, (struct sockaddr *)&cli, socklen))
	  err_quit("connect");
     printf("connected to socket %s\n", cli.sun_path);

     /* Copy stdin to the socket file descriptor */
     xfer_data(fileno(stdin), sockfd);

     exit(EXIT_SUCCESS);
}
     
